#include <vga.h>
extern int swScanWidth;
extern int color_index;

int bpp8_fillbox(int x,int y,int w,int h)
{
  int n;
  int addr = y * swScanWidth + x;
  unsigned char * gp = vga_getgraphmem();
  unsigned char * p  = gp;
  int page = addr >>16;
  int next;
  int dp;
  
  vga_setpage(page);
  addr &= 0xffff;
  next = addr + w;
  p   += addr;
  
  for (n=0;n<h;n++,addr+=swScanWidth,next+=w) {
    if (addr>0xffff) {
      page++;
      vga_setpage(page);
      addr &= 0xffff;
      next = addr + w;
      p = gp;
      p += addr;
    }
    if (next>0x10000) {
      dp = 0x10000 - addr;
      memset(p,color_index,dp);
      vga_setpage(page+1);
      p = gp;
      memset(p,color_index,w-dp);
    } else {
      memset(p,color_index,w);
      p += swScanWidth;
    }
  }

  return 1;
}
